/**
  * Copyright (C) 2004-2005 Till Riedel. All rights reserved.
  * 
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
  * are met:
  * 1. Redistributions of source code must retain the above copyright
  *    notice, this list of conditions and the following disclaimer.
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
  * 
  * THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  * ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
 **/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libparticle.h>

extern void print_pdebug(char *data,int len);
int
main(int argc, char *argv[])
{
	struct p_packet *packet = NULL;

        int port=5555;
	int sockd ;
        int seq=-1;
        char file[256];

        *file=0;

        fprintf(stderr,"listening on port: %d\n",port);

        sockd= p_socket_open(0,0,port);

	for (;;) {
                fflush(stdout);
		packet = p_socket_recv(sockd, 0);
		if (packet != NULL ) {
                  char id[32];
                  char location[172];
                  struct p_acl_tuple *tuple = p_acl_first(packet);
                  p_pkt_get_srcid_str(packet, id, sizeof(id));
                  p_pkt_get_location_str(packet, location, sizeof(location));
                  if(p_pkt_get_seq(packet)!=seq && (argc==1 || strcmp(id,argv[1])==0 || argc==2 || strcmp(location,argv[2])==0 )) 
                  while (tuple != NULL) 
                  {
                    uint8_t *acl_type=p_acl_get_type(tuple);

                    if(198==acl_type[0] && 248==acl_type[1])
                      putchar('.');
                    if(102==acl_type[0] && 102==acl_type[1])
                    { 
                      int i;
                      char *acl_data;
                      int acl_len=p_acl_get_data(tuple,&acl_data);

                      putchar('[');
                      for(i=0;i<acl_len;i++)putchar(acl_data[i]);
                      putchar(']');
                      putchar('\n');
                    }

                    if(127==acl_type[0] && 105==acl_type[1])
                    {
                      char *acl_data;
                      int acl_len=p_acl_get_data(tuple,&acl_data);
                      print_pdebug(acl_data,acl_len);
                    }
                    tuple = p_acl_next(packet, tuple);
                  }
                  seq=p_pkt_get_seq(packet);
                } else {
#ifdef WIN32
                  printf("p_socket_recv: %d\n", WSAGetLastError());
#else
                  perror("p_socket_recv: ");
#endif
                }
                p_pkt_free(packet);
        }


        return (0);
}
