/*
 * Created on 23.03.2005
 *
 * Copyright (c) 2004
 * Telecooperation Office (TecO), Universitaet Karlsruhe (TH), Germany.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 * 3. Neither the name of the Universitaet Karlsruhe (TH) nor the names
 *    of its contributors may be used to endorse or promote products
 *    derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

package edu.teco.particles.pComponent.scanner;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import edu.teco.particles.libParticle.ParticlePacket;
import edu.teco.particles.pComponent.SocketThread;

/**
 * JButton with default action.
 * 
 * @author scholl
 * 
 * Sends a CHE packet to all.
 */
public class ScanNetworkAction extends AbstractAction
{
  public void actionPerformed(ActionEvent e)
  {
    assert (_socket != null) : "socket not initialized";
    ParticlePacket hello = new ParticlePacket();
    short data[] = { 255, 255, 255, 255, 255, 255, 255, 255 };
    short empt[] = {};
    hello.aclAdd("acm", empt, 0);
    hello.aclAdd("che", data, 0);
    _socket.send(hello);
  }

  protected SocketThread _socket = null;

  public void setSocket(SocketThread sock)
  {
    _socket = sock;
  }

  public SocketThread getSocket()
  {
    return _socket;
  }

}
